# Purpose of References

Besides using references of annotations to WSIs as constraints to decide if they are valid inputs for an app, there are also other reasons to make use of references for generated outputs. For example to link information and to present the data in a structured way.

## Example

Consider the fourth app of the tutorial:

* Input:
  * The app receives one WSI as input `my_wsi`
  * Aswell as `1-n` rectangle annotation `my_rectangles`

* Output:
  * In each rectangle it finds cells, therefore outputs a collection of collections of points `my_cells`
  * Each cell is further analyzed and assigned a score `my_confidences`


```JSON
{
    "$schema": "https://developer.empaia.org/schema/ead-app-schema-draft-3.json",
    "name": "Tutorial App 04",
    "name_short": "TA04",
    "namespace": "org.empaia.vendor_name.tutorial_app_04.v1",
    "description": "Human readable description",
    "inputs": {
        "my_wsi": {
            "type": "wsi"
        },
        "my_rectangles": {
            "type": "collection",
            "reference": "inputs.my_wsi",
            "items": {
                "type": "rectangle",
                "reference": "inputs.my_wsi"
            }
        }
    },
    "outputs": {
        "my_cells": {
            "type": "collection",
            "items": {
                "type": "collection",
                "reference": "inputs.my_rectangles.items",
                "items": {
                    "type": "point",
                    "reference": "inputs.my_wsi"
                }
            }
        },
        "my_confidences": {
            "type": "collection",
            "items": {
                "type": "collection",
                "items": {
                    "type": "float",
                    "reference": "outputs.my_cells.items.items"
                }
            }
        }
    }
}
```

## Structured Presentation

The data generated by this app can be presented in a tree view as follows:

```
my_wsi
├── rectangle_1
    ├── cell_1_1
    ├── (...)
    └── cell_1_123
└── rectangle_2
    ├── cell_2_1
    ├── (...)
    └── cell_2_456
```

For this representation the direct references of annotations to the WSI are ignored, if they are contained in a collection, that has references to another annotation. Therefore `cell_1_1` appears as a child node of `rectangle_1` and not as a child node of `my_wsi`.

Primitive data types do not appear as a node in the tree view. Instead in the WBC 1.0 it is possible to select a node to show all primitive data results that have a direct reference to the specific node. For primitive data types collection references will not be taken into account. For example, selecting `cell_1_1` shows `confidence_1_1`, if the app creates this reference.
